orte/mca/ns/ns.h File Reference.TH "orte/mca/ns/ns.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/ns/ns.h \- The Open MPI Name Server. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/constants.h'\fP
.br
\fC#include 'include/orte_types.h'\fP
.br
\fC#include 'dps/dps.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/oob/oob_types.h'\fP
.br
\fC#include 'ns_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_NS_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_init_fn_t\fP )(void)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_create_cellid_fn_t\fP )(orte_cellid_t *cellid, char *site, char *resource)"
.br
.RI "\fICreate a new cell id. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_cell_info_fn_t\fP )(orte_cellid_t cellid, char **site, char **resource)"
.br
.RI "\fIGet cell info Retrieve the site and resource info on a cell. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_assign_cellid_to_process_fn_t\fP )(orte_process_name_t *name)"
.br
.RI "\fIGet the cell id for a process. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_cellid_string_fn_t\fP )(char **cellid_string, const orte_process_name_t *name)"
.br
.RI "\fIGet the cell id as a character string. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_cellid_to_string_fn_t\fP )(char **cellid_string, const orte_cellid_t cellid)"
.br
.RI "\fIConvert cellid to character string Returns the cellid in a character string representation. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_string_to_cellid_fn_t\fP )(orte_cellid_t *cellid, const char *cellidstring)"
.br
.RI "\fIConvert a string to a cellid. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_cellid_fn_t\fP )(orte_cellid_t *cellid, const orte_process_name_t *name)"
.br
.RI "\fIGet the cell id as a numberic value. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_create_jobid_fn_t\fP )(\fBorte_jobid_t\fP *jobid)"
.br
.RI "\fICreate a new job id. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_reserve_range_fn_t\fP )(\fBorte_jobid_t\fP job, orte_vpid_t range, orte_vpid_t *startvpid)"
.br
.RI "\fIReserve a range of process id's. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_jobid_string_fn_t\fP )(char **jobid_string, const orte_process_name_t *name)"
.br
.RI "\fIGet the job id as a character string. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_jobid_to_string_fn_t\fP )(char **jobid_string, const \fBorte_jobid_t\fP jobid)"
.br
.RI "\fIConvert jobid to character string The convert_jobid_to_string() function returns the jobid in a character string representation. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_string_to_jobid_fn_t\fP )(\fBorte_jobid_t\fP *jobid, const char *jobidstring)"
.br
.RI "\fIConvert a string to a jobid Converts a character string into a jobid. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_jobid_fn_t\fP )(\fBorte_jobid_t\fP *jobid, const orte_process_name_t *name)"
.br
.RI "\fIGet the job id as a numeric value. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_create_proc_name_fn_t\fP )(orte_process_name_t **name, orte_cellid_t cell, \fBorte_jobid_t\fP job, orte_vpid_t vpid)"
.br
.RI "\fIObtain a single new process name. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_create_my_name_fn_t\fP )(void)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_copy_proc_name_fn_t\fP )(orte_process_name_t **dest, orte_process_name_t *src)"
.br
.RI "\fIMake a copy of a process name. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_string_to_process_name_fn_t\fP )(orte_process_name_t **name, const char *name_string)"
.br
.RI "\fIConvert a string representation to a process name. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_free_name_fn_t\fP )(orte_process_name_t **name)"
.br
.RI "\fIFree (release) a process name. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_proc_name_string_fn_t\fP )(char **name_string, const orte_process_name_t *name)"
.br
.RI "\fIGet the process name as a character string. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_compare_fn_t\fP )(\fBorte_ns_cmp_bitmask_t\fP fields, const orte_process_name_t *name1, const orte_process_name_t *name2)"
.br
.RI "\fICompare two name values. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_vpid_string_fn_t\fP )(char **vpid_string, const orte_process_name_t *name)"
.br
.RI "\fIGet the virtual process id as a character string. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_vpid_to_string_fn_t\fP )(char **vpid_string, const orte_vpid_t vpid)"
.br
.RI "\fIConvert vpid to character string Returns the vpid in a character string representation. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_convert_string_to_vpid_fn_t\fP )(orte_vpid_t *vpid, const char *vpidstring)"
.br
.RI "\fIConvert a string to a vpid. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_vpid_fn_t\fP )(orte_vpid_t *vpid, const orte_process_name_t *name)"
.br
.RI "\fIGet the virtual process id as a numeric value. \fP"
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_assign_rml_tag_fn_t\fP )(\fBorte_rml_tag_t\fP *tag, char *name)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_define_data_type_fn_t\fP )(const char *name, \fBorte_data_type_t\fP *type)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_peers_fn_t\fP )(orte_process_name_t **procs, size_t *num_procs, size_t *self)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_get_job_peers_fn_t\fP )(orte_process_name_t **procs, size_t *num_procs, \fBorte_jobid_t\fP job)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_dump_cells_fn_t\fP )(int output_id)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_dump_jobs_fn_t\fP )(int output_id)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_dump_tags_fn_t\fP )(int output_id)"
.br
.ti -1c
.RI "typedef int(* \fBorte_ns_base_module_dump_datatypes_fn_t\fP )(int output_id)"
.br
.ti -1c
.RI "typedef mca_ns_base_module_1_0_0_t \fBmca_ns_base_module_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef mca_ns_base_module_1_0_0_t \fBmca_ns_base_module_t\fP"
.br
.ti -1c
.RI "typedef mca_ns_base_module_t *(* \fBmca_ns_base_component_init_fn_t\fP )(int *priority)"
.br
.RI "\fIInitialize the selected component. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ns_base_component_finalize_fn_t\fP )(void)"
.br
.RI "\fIFinalize the selected module. \fP"
.ti -1c
.RI "typedef mca_ns_base_component_1_0_0_t \fBmca_ns_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef mca_ns_base_component_1_0_0_t \fBmca_ns_base_component_t\fP"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC mca_ns_base_module_t \fBorte_ns\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
The Open MPI Name Server. 

The Open MPI Name Server provides unique name ranges for processes within the universe. Each universe will have one name server running within the seed daemon. This is done to prevent the inadvertent duplication of names.
.SH "Define Documentation"
.PP 
.SS "#define MCA_NS_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* ns v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* ns v1.0 */ \
  'ns', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBorte_ns_base_module_assign_cellid_to_process_fn_t\fP)(orte_process_name_t *name)"
.PP
Get the cell id for a process. 
.PP
The cellid designator represents the physical location of the process - it is associated with the hardware/system where the process is executing. Each process name contains this identifier so that the system can issue commands (e.g., 'die') to a collection of processes that are executing on a common platform.
.PP
Given that usage, it is necessary that the system have a way of telling a process its cellid. The create_cellid() function is used by the system to associate a 'cellid' identifier with each platform. This function - assign_cellid_to_process() - is used to inform the process of its cellid.
.PP
Given a process name, this function will lookup its current platform and update the name with the cellid.
.PP
\fBParameters:\fP
.RS 4
\fIname\fP Pointer to an ompi_process_name structure. The function will update the cellid entry in the structure.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Update was successful. 
.br
\fIOMPI_ERROR\fP Update failed, most likely due to either a NULL process name pointer or the inability to locate the process name in the lookup table.
.RE
.PP
.PP
.nf
 return_value = ompi_name_server.assign_cellid_to_process(ompi_process_name_t* name);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_compare_fn_t\fP)(\fBorte_ns_cmp_bitmask_t\fP fields, const orte_process_name_t *name1, const orte_process_name_t *name2)"
.PP
Compare two name values. 
.PP
The compare() function checks the value of the fields in the two provided names, and returns a value indicating if the first one is less than, greater than, or equal to the second. The value of each field is compared in a hierarchical fashion, with cellid first, followed by jobid and vpid in sequence. The bit-mask indicates which fields are to be included in the comparison. Fields not included via the bit-mask are ignored. Thus, the caller may request that any combination of the three fields be included in the comparison.
.PP
\fBParameters:\fP
.RS 4
\fIfields\fP A bit-mask indicating which fields are to be included in the comparison. The comparison is performed on a hierarchical basis, with cellid being first, followed by jobid and then vpid. Each field can be included separately, thus allowing the caller to configure the comparison to meet their needs. 
.br
\fI*name1\fP A pointer to the first name structure. 
.br
\fI*name2\fP A pointer to the second name structure.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI-1\fP The indicated fields of the first provided name are less than the same fields of the second provided name. 
.br
\fI0\fP The indicated fields of the two provided names are equal. 
.br
\fI+1\fP The indicated fields of the first provided name is greater than the same fields of the second provided name.
.RE
.PP
The function returns a large negative value if there is an error.
.PP
.PP
.nf
 result = ompi_name_server.compare(bit_mask, &name1, &name2)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_cellid_to_string_fn_t\fP)(char **cellid_string, const orte_cellid_t cellid)"
.PP
Convert cellid to character string Returns the cellid in a character string representation. 
.PP
The string is created by expressing the provided cellid in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fIcellid\fP The cellid to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*cellid_string\fP A pointer to a character string representation of the cellid. 
.br
\fINULL\fP Indicates an error occurred - probably no memory could be allocated.
.RE
.PP
.PP
.nf
 cellid-string = ompi_name_server.convert_cellid_to_string(cellid);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_jobid_to_string_fn_t\fP)(char **jobid_string, const \fBorte_jobid_t\fP jobid)"
.PP
Convert jobid to character string The convert_jobid_to_string() function returns the jobid in a character string representation. 
.PP
The string is created by expressing the provided jobid in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP The jobid to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*jobid_string\fP A pointer to a character string representation of the jobid. 
.br
\fINULL\fP Indicates an error occurred - probably no memory could be allocated.
.RE
.PP
.PP
.nf
 jobid-string = ompi_name_server.convert_jobid_to_string(jobid);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_string_to_cellid_fn_t\fP)(orte_cellid_t *cellid, const char *cellidstring)"
.PP
Convert a string to a cellid. 
.PP
Converts a characters string into a cellid. The character string must be a hexadecimal representation of a valid cellid.
.PP
\fBParameters:\fP
.RS 4
\fIcellidstring\fP The string to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIcellid\fP The resulting cellid 
.br
\fIMCA_NS_BASE_CELLID_MAX\fP String could not be converted.
.RE
.PP
.PP
.nf
 cellid = ompi_name_server.convert_string_to_cellid(cellidstring);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_string_to_jobid_fn_t\fP)(\fBorte_jobid_t\fP *jobid, const char *jobidstring)"
.PP
Convert a string to a jobid Converts a character string into a jobid. 
.PP
The character string must be a hexadecimal representation of a valid jobid.
.PP
\fBParameters:\fP
.RS 4
\fIjobidstring\fP The string to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIjobid\fP The resulting jobid. 
.br
\fIMCA_NS_BASE_JOBID_MAX\fP String could not be converted.
.RE
.PP
.PP
.nf
 jobid = ompi_name_server.convert_string_to_jobid(jobidstring);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_string_to_process_name_fn_t\fP)(orte_process_name_t **name, const char *name_string)"
.PP
Convert a string representation to a process name. 
.PP
The convert_string_to_process_name() function converts a string representation of a process name into an Open MPI name structure. The string must be of the proper form - i.e., it must be in the form 'cellid.jobid.vpid', where each field is expressed in hexadecimal form.
.PP
\fBParameters:\fP
.RS 4
\fI*name_string\fP A character string representation of a process name.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name\fP Pointer to an ompi_process_name_t structure containing the name. 
.br
\fINULL\fP Indicates an error, probably due to inability to allocate memory for the name structure.
.RE
.PP
.PP
.nf
 name = ompi_name_server.convert_string_to_process_name(name_string);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_string_to_vpid_fn_t\fP)(orte_vpid_t *vpid, const char *vpidstring)"
.PP
Convert a string to a vpid. 
.PP
Converts a characters string into a vpid. The character string must be a hexadecimal representation of a valid vpid.
.PP
\fBParameters:\fP
.RS 4
\fIvpidstring\fP The string to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIvpid\fP The resulting vpid 
.br
\fIMCA_NS_BASE_VPID_MAX\fP String could not be converted.
.RE
.PP
.PP
.nf
 vpid = ompi_name_server.convert_string_to_vpid(vpidstring);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_convert_vpid_to_string_fn_t\fP)(char **vpid_string, const orte_vpid_t vpid)"
.PP
Convert vpid to character string Returns the vpid in a character string representation. 
.PP
The string is created by expressing the provided vpid in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fIvpid\fP The vpid to be converted.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*vpid_string\fP A pointer to a character string representation of the vpid. 
.br
\fINULL\fP Indicates an error occurred - probably no memory could be allocated.
.RE
.PP
.PP
.nf
 vpid-string = ompi_name_server.convert_vpid_to_string(vpid);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_copy_proc_name_fn_t\fP)(orte_process_name_t **dest, orte_process_name_t *src)"
.PP
Make a copy of a process name. 
.PP
Given a process name, this function creates a copy of it and returns a pointer to the duplicate structure.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP Pointer to an existing process name structure.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*newname\fP Pointer to the duplicate structure, with all fields transferred. 
.br
\fINULL\fP Indicates an error - most likely due to a NULL process name pointer being supplied as input. 
.RE
.PP

.SS "typedef int(* \fBorte_ns_base_module_create_cellid_fn_t\fP)(orte_cellid_t *cellid, char *site, char *resource)"
.PP
Create a new cell id. 
.PP
The create_cellid() function allocates a new cell id for use by the caller. The function checks to find the next available cell id, reserves it, and returns that number. No memory for names is allocated by this process. The range of answers is from 1 to MCA_NS_BASE_CELLID_MAX-1 (zero is reserved for the seed name and cannot therefore be allocated).
.PP
\fBParameters:\fP
.RS 4
\fIsite\fP The name of the site where the cell is located. 
.br
\fIresource\fP The name of the resource associated with this cell (e.g., the name of the cluster). 
.br
\fIcellid\fP The numerical value of the allocated cell id. A value of MCA_NS_BASE_CELLID_MAX indicates that an error occurred - this represents a very unlikely event meaning that the system ran out of cell id's. This probably indicates an error in the calling program as the number of available cell id's is extremely large.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP A cellid was created and returned. 
.br
\fIORTE_ERROR_VALUE\fP An error code indicative of the problem.
.RE
.PP
.PP
.nf
 new_cellid = ompi_name_server.create_cellid()
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_create_jobid_fn_t\fP)(\fBorte_jobid_t\fP *jobid)"
.PP
Create a new job id. 
.PP
The create_jobid() function allocates a new job id for use by the caller. The function checks to find the next available job id, reserves it, and returns that number. No memory for names is allocated by this process. The range of answers is from 1 to MCA_NS_BASE_JOBID_MAX-1 (zero is reserved for the seed name and cannot therefore be allocated).
.PP
The 0 job id is reserved for daemons within the system and will not be allocated. Developers should therefore assume that the daemon job id is automatically allocated and proceed to request names against it.
.PP
\fBParameters:\fP
.RS 4
\fINone\fP .RE
.PP
\fBReturn values:\fP
.RS 4
\fIjobid\fP The numerical value of the allocated job id. A value of MCA_NS_BASE_JOBID_MAX indicates that an error occurred - this represents a very unlikely event meaning that the system ran out of job id's. This probably indicates an error in the calling program as the number of available job id's is extremely large.
.RE
.PP
.PP
.nf
 new_jobid = ompi_name_server.create_jobid()
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_create_proc_name_fn_t\fP)(orte_process_name_t **name, orte_cellid_t cell, \fBorte_jobid_t\fP job, orte_vpid_t vpid)"
.PP
Obtain a single new process name. 
.PP
The create_process_name() function creates a single process name structure and fills the fields with the provided values.
.PP
\fBParameters:\fP
.RS 4
\fIcell\fP The cell for which the process name is intended. Usually, this is the id of the cell where the process is initially planning to be spawned. 
.br
\fIjob\fP The id of the job to which the process will belong. Process id's are tracked according to jobid, but not cellid. Thus, two processes can have the same process id if and only if they have different jobid's. However, two processes in the same jobid cannot have the same process id, regardless of whether or not they are in the same cell. 
.br
\fIvpid\fP The virtual process id for the name. Note that no check is made for uniqueness - the caller is responsible for ensuring that the requested name is, in fact, unique by first requesting reservation of an appropriate range of virtual process id's.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name\fP Pointer to an ompi_process_name_t structure containing the name. 
.br
\fINULL\fP Indicates an error, probably due to inability to allocate memory for the name structure.
.RE
.PP
.PP
.nf
 new_name = ompi_name_server.create_process_name(cell, job, vpid);
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_free_name_fn_t\fP)(orte_process_name_t **name)"
.PP
Free (release) a process name. 
.PP
The free_name() function releases the process name from the 'used' list maintained within the name server for the jobid contained in the specified name. The memory for the name is also released at that time.
.PP
Name values are currently \fInot\fP re-used. Hence, free-ing a name does not provide any noticeable benefit other than releasing the memory. In the future, names may be re-used if this becomes desirable.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name being released.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Indicates the release was succesfully accomplished. 
.br
\fIOMPI_ERROR\fP Indicates the release failed - most likely due to an error when free-ing the memory allocation.
.RE
.PP
.PP
.nf
 if (OMPI_ERROR == ompi_name_server.free_name(&name) {
     report error
     }
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_cell_info_fn_t\fP)(orte_cellid_t cellid, char **site, char **resource)"
.PP
Get cell info Retrieve the site and resource info on a cell. 
.PP
\fBParameters:\fP
.RS 4
\fIcellid\fP The id of the cell who's info is being requested. 
.br
\fIsite\fP Returns a pointer to a strdup'd string containing the site name. 
.br
\fIresource\fP Returns a pointer to a strdup'd string containg the resource name. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP A cellid was created and returned. 
.br
\fIORTE_ERROR_VALUE\fP An error code indicative of the problem. 
.RE
.PP

.SS "typedef int(* \fBorte_ns_base_module_get_cellid_fn_t\fP)(orte_cellid_t *cellid, const orte_process_name_t *name)"
.PP
Get the cell id as a numberic value. 
.PP
The get_cellid() function returns the cell id in a numeric representation - i.e., in an integer form.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIcellid\fP The cell id field of the provided name. 
.br
\fIMCA_NS_BASE_CELLID_MAX\fP Indicates that an error occurred - in this case, that the name variable provided was NULL.
.RE
.PP
.PP
.nf
 cellid = ompi_name_server.get_cellid(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_cellid_string_fn_t\fP)(char **cellid_string, const orte_process_name_t *name)"
.PP
Get the cell id as a character string. 
.PP
The get_cellid_string() function returns the cell id in a character string representation. The string is created by expressing the field in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name to be 'translated' to a string.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name_string\fP A pointer to the character string representation of the cell id. 
.br
\fINULL\fP Indicates an error occurred - either no memory could be allocated or the caller provided an incorrect name pointer (e.g., NULL).
.RE
.PP
.PP
.nf
 cellid-string = ompi_name_server.get_cellid_string(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_jobid_fn_t\fP)(\fBorte_jobid_t\fP *jobid, const orte_process_name_t *name)"
.PP
Get the job id as a numeric value. 
.PP
The get_jobid() function returns the job id in a numeric representation - i.e., in an integer form.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIjobid\fP The job id field of the provided name. 
.br
\fIMCA_NS_BASE_JOBID_MAX\fP Indicates that an error occurred - in this case, that the name variable provided was NULL.
.RE
.PP
.PP
.nf
 jobid = ompi_name_server.get_jobid(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_jobid_string_fn_t\fP)(char **jobid_string, const orte_process_name_t *name)"
.PP
Get the job id as a character string. 
.PP
The get_jobid_string() function returns the job id in a character string representation. The string is created by expressing the field in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name to be 'translated' to a string.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name_string\fP A pointer to the character string representation of the job id. 
.br
\fINULL\fP Indicates an error occurred - either no memory could be allocated or the caller provided an incorrect name pointer (e.g., NULL).
.RE
.PP
.PP
.nf
 jobid-string = ompi_name_server.get_jobid_string(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_proc_name_string_fn_t\fP)(char **name_string, const orte_process_name_t *name)"
.PP
Get the process name as a character string. 
.PP
The get_proc_name_string() function returns the entire process name in a character string representation. The string is created by expressing each field in hexadecimal separated by periods, as follows:
.PP
sprintf(string_name, '%x.%x.%x', cellid, jobid, vpid)
.PP
The memory required for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name to be 'translated' to a string.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name_string\fP A pointer to the character string representation of the full name. 
.br
\fINULL\fP Indicates an error occurred - either no memory could be allocated or the caller provided an incorrect name pointer (e.g., NULL).
.RE
.PP
.PP
.nf
 name-string = ompi_name_server.get_proc_name_string(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_vpid_fn_t\fP)(orte_vpid_t *vpid, const orte_process_name_t *name)"
.PP
Get the virtual process id as a numeric value. 
.PP
The get_vpid() function returns the vpid in a numeric representation - i.e., in an integer form.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIvpid\fP The vpid field of the provided name. 
.br
\fIMCA_NS_BASE_VPID_MAX\fP Indicates that an error occurred - in this case, that the name variable provided was NULL.
.RE
.PP
.PP
.nf
 vpid = ompi_name_server.get_vpid(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_get_vpid_string_fn_t\fP)(char **vpid_string, const orte_process_name_t *name)"
.PP
Get the virtual process id as a character string. 
.PP
The get_vpid_string() function returns the vpid in a character string representation. The string is created by expressing the field in hexadecimal. Memory for the string is allocated by the function - releasing that allocation is the responsibility of the calling program.
.PP
\fBParameters:\fP
.RS 4
\fI*name\fP A pointer to the name structure containing the name to be 'translated' to a string.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*name_string\fP A pointer to the character string representation of the vpid. 
.br
\fINULL\fP Indicates an error occurred - either no memory could be allocated or the caller provided an incorrect name pointer (e.g., NULL).
.RE
.PP
.PP
.nf
 vpid-string = ompi_name_server.get_vpid_string(&name)
.fi
.PP
 
.SS "typedef int(* \fBorte_ns_base_module_reserve_range_fn_t\fP)(\fBorte_jobid_t\fP job, orte_vpid_t range, orte_vpid_t *startvpid)"
.PP
Reserve a range of process id's. 
.PP
The reserve_range() function reserves a range of vpid's for the given jobid. Note that the cellid does not factor into this request - jobid's span the entire universe, hence the cell where the process is currently executing is irrelevant to this request.
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP The id of the job for which the vpid's are to be reserved. 
.br
\fIrange\fP The number of vpid's to be reserved. The function will find the next available process id and assign range-number of sequential id's to the caller. These id's will be reserved - i.e., they cannot be assigned to any subsequent caller.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIstartid\fP The starting value of the reserved range of vpid's. A value of MCA_NS_BASE_VPID_MAX indicates that an error occurred.
.RE
.PP
.PP
.nf
 starting_procid = ompi_name_server.reserve_range(jobid, range)
.fi
.PP
 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
